#include <stdio.h>
#include <usb.h>

int main(void)
{
  //adresa vybraneho zarizeni
  u_int16_t myVendor = 0x045E;
  u_int16_t myProduct = 0x0040;

  struct usb_bus *bus;
  struct usb_device *dev;
  usb_dev_handle *udev;
  int claim, ret;

  //inicializace usb
  usb_init();

  //nalezeni usb zarizeni a sbernic
  usb_find_busses();
  usb_find_devices();

  //prochazeni vsech sbernic a zarizeni na nich
  for (bus = usb_busses; bus; bus = bus->next) {
    for (dev = bus->devices; dev; dev = dev->next) {
      int ret, i;
      char string[256];

      //aktivace usb zarizeni
      udev = usb_open(dev);



      //hledani vybraneho zarizeni pro komunikaci
      if ((dev->descriptor.idVendor == myVendor) && 
          (dev->descriptor.idProduct == myProduct)) {
        printf("OK\n");

        //otevreni komunikanho kanalu
        usb_set_configuration(udev, dev->config[0].bConfigurationValue);

        claim = usb_claim_interface(udev, 0);
  
        if(dev->config[0].interface[0].altsetting[0].bNumEndpoints == 0) { 
          printf("BAD Endpoint/n"); exit(2);
        }
  
        while (1) {
          char string[10];

          //cteni ze zarizeni
          ret = usb_interrupt_read(udev,
            dev->config[0].interface[0].altsetting[0].endpoint[0].bEndpointAddress,
            string,
            dev->config[0].interface[0].altsetting[0].endpoint[0].wMaxPacketSize,
            dev->config[0].interface[0].altsetting[0].endpoint[0].bInterval);
//          printf("%d \n", ret);
          if (ret >= 0) {
            printf("Data: %4d %4d %4d %4d %4d %4d %4d %4d\n",
                   string[0], string[1], string[2], string[3],
	             string[4], string[5], string[6], string[7]);
	    }
//          usleep(dev->config[0].interface[0].altsetting[0].endpoint[0].bInterval*1000);
        }
      }
    }
  }
  printf("BAD\n");
  exit(1);
}
